package ast

import (
	"git.akyoto.dev/cli/q/src/build/expression"
	"git.akyoto.dev/cli/q/src/build/token"
)

type Node interface{}
type AST []Node

type Assign struct {
	Value *expression.Expression
	Name  token.Token
}

type Call struct {
	Expression *expression.Expression
}

type Define struct {
	Value *expression.Expression
	Name  token.Token
}

type If struct {
	Condition *expression.Expression
	Body      AST
}

type Loop struct {
	Body AST
}

type Return struct {
	Value *expression.Expression
}
